# -*- coding: utf-8 -*-
from physics import PhysicsEngine
from itertools import combinations
import numpy as np

class PhysicsEngineEuler(PhysicsEngine):
    
    dt = None

    def __init__(self, world, dt):
        super(PhysicsEngineEuler, self).__init__(world)
        self.dt = dt

    def step(self):
        world_objects = self.world.world_objects.values()
        
        #reset force
        for wo in world_objects:
            wo.force = np.zeros(3)
            
        pairs = combinations(world_objects, 2)

        #force loop
        for wo1, wo2 in pairs:
            force = self.grav_force(wo1.position, wo2.position, wo1.mass, wo2.mass)
            wo1.force += force
            wo2.force -= force

        #movement loop
        for wo in world_objects:
            wo.velocity += wo.force / wo.mass * self.dt
            wo.position += wo.velocity * self.dt
        
        self.world.time += self.dt